<template>
  <div>
    <!-- 数据表格 -->
    <ele-pro-table
      ref="table"
      :columns="columns"
      :datasource="datasource"
      height="calc(100vh - 265px)"
      full-height="calc(100vh - 116px)"
      tool-class="ele-toolbar-form"
      cache-key="systemOrgUserTable"
    >
      <!-- 表头工具栏 -->
      <template v-slot:toolbar>
        <code-search @search="reload">
          <el-button
            size="small"
            type="primary"
            icon="el-icon-plus"
            class="ele-btn-icon"
            @click="openEdit()"
          >
            添加
          </el-button>
        </code-search>
      </template>
      <!-- 操作列 -->
      <template v-slot:action="{ row }">
        <el-link
          type="primary"
          :underline="false"
          icon="el-icon-edit"
          @click="openEdit(row)"
        >
          编辑
        </el-link>
        <el-popconfirm
          class="ele-action"
          title="确定要删除此用户吗？"
          @confirm="remove(row)"
        >
          <template v-slot:reference>
            <el-link type="danger" :underline="false" icon="el-icon-delete">
              删除
            </el-link>
          </template>
        </el-popconfirm>
      </template>
    </ele-pro-table>
    <!-- 编辑弹窗 -->
    <addDialog ref="addDialog" @done="reload"></addDialog>
  </div>
</template>

<script>
import CodeSearch from './code-search.vue';
import addDialog from './addDialog.vue';
import { getCodeList, removeCodeInfo } from '@/api/codeManagement/index';

export default {
  components: { CodeSearch, addDialog },
  props: {
    // 机构id
    organizationId: [Number, String],
    // 全部机构
    organizationList: Array
  },
  data() {
    return {
      // 表格列配置
      columns: [
        {
          columnKey: 'index',
          type: 'index',
          width: 45,
          align: 'center',
          showOverflowTooltip: true,
          fixed: 'left'
        },
        {
          prop: 'code',
          label: '编码',
          // sortable: 'custom',
          showOverflowTooltip: true,
          minWidth: 110
        },
        {
          prop: 'name',
          label: '名称',
          // sortable: 'custom',
          showOverflowTooltip: true,
          minWidth: 110
        },
        {
          prop: 'remark',
          label: '描述',
          align: 'left',
          // sortable: 'custom',
          minWidth: 200,
          showOverflowTooltip: true
        },
        {
          columnKey: 'action',
          label: '操作',
          width: 130,
          align: 'center',
          resizable: false,
          slot: 'action',
          showOverflowTooltip: true
        }
      ],
      // 当前编辑数据
      current: null,
      // 是否显示编辑弹窗
      showEdit: false
    };
  },
  methods: {
    /* 表格数据源 */
    datasource({ page, limit, where, order }) {
      return getCodeList({
        ...where,
        ...order,
        pageNum: page,
        size: limit
        // groupId: 1
      });
    },
    /* 刷新表格 */
    reload(where) {
      this.$refs.table.reload({ pageNum: 1, where: where });
    },
    /* 显示编辑 */
    openEdit(row) {
      if (row) {
        this.$refs.addDialog.open('edit', row);
      } else {
        this.$refs.addDialog.open('add');
      }
    },
    /* 删除 */
    remove(row) {
      const loading = this.$loading({ lock: true });
      removeCodeInfo([row.id])
        .then((msg) => {
          loading.close();
          this.$message.success(msg);
          this.reload();
        })
        .catch((e) => {
          loading.close();
          // this.$message.error(e.message);
        });
    }
  },
  watch: {
    // 监听机构id变化
    // organizationId() {
    //   this.reload();
    // }
  }
};
</script>
